TABMERGE(1p)

NAME
tabmerge - unify delimited files on common fields

SYNOPSIS
  tabmerge [action] [options] file1 file2 [...]

Actions:

  --min                Take only fields present in all files [DEFAULT]
  --max                Take all fields present
  -f|--fields=f1[,f2]  Take only the fields mentioned in the
                       comma-separated list

Options:

  -l|--list            List available fields
  --fs=x               Use "x" as the field separator
                       (default is tab "\t")
  --rs=x               Use "x" as the record separator
                       (default is newline "\n")
  -s|--sort=f1[,f2]    Sort data ASCII-betically on field(s)
  --stdout             Print data in original delimited format
                       (i.e., not in a table format)

  --help               Show brief help and quit
  --man                Show full documentation

DESCRIPTION
This program merges the fields -- not the rows -- of delimited text files. That is, if several files are almost but not quite entirely unlike each other in their structure (in their field names, numbers or orders), this script allows you to easily unify the files into one file with all the same fields. The output can be based on fields as determined by the three "action" flags.

For the following examples, consider three files that contain the following fields:

  +------------+---------------------------------+
  | File       | Fields                          |
  +------------+---------------------------------+
  | merge1.tab | name, type, position            |
  | merge2.tab | name, type, position, lod_score |
  | merge3.tab | name, position                  |
  +------------+---------------------------------+

To list all available fields in the files and the number of times they are present:

  $ tabmerge --list merge*
  +-----------+-------------------+
  | Field     | No. Times Present |
  +-----------+-------------------+
  | lod_score | 1                 |
  | name      | 3                 |
  | position  | 3                 |
  | type      | 2                 |
  +-----------+-------------------+

To merge the files on the minimum overlapping fields:

  $ tabmerge merge*
  +----------+----------+
  | name     | position |
  +----------+----------+
  | RM104    | 2.30     |
  | RM105    | 4.5      |
  | TX5509   | 10.4     |
  | UU189    | 19.0     |
  | Xpsm122  | 3.3      |
  | Xpsr9556 | 4.5      |
  | DRTL     | 2.30     |
  | ALTX     | 4.5      |
  | DWRF     | 10.4     |
  +----------+----------+

To merge the files and include all the fields:

  $ tabmerge --max merge*
  +-----------+----------+----------+--------+
  | lod_score | name     | position | type   |
  +-----------+----------+----------+--------+
  |           | RM104    | 2.30     | RFLP   |
  |           | RM105    | 4.5      | RFLP   |
  |           | TX5509   | 10.4     | AFLP   |
  | 2.4       | UU189    | 19.0     | SSR    |
  | 1.2       | Xpsm122  | 3.3      | Marker |
  | 1.2       | Xpsr9556 | 4.5      | Marker |
  |           | DRTL     | 2.30     |        |
  |           | ALTX     | 4.5      |        |
  |           | DWRF     | 10.4     |        |
  +-----------+----------+----------+--------+

To merge and extract just the "name" and "type" fields:

  $ tabmerge -f name,type merge*
  +----------+--------+
  | name     | type   |
  +----------+--------+
  | RM104    | RFLP   |
  | RM105    | RFLP   |
  | TX5509   | AFLP   |
  | UU189    | SSR    |
  | Xpsm122  | Marker |
  | Xpsr9556 | Marker |
  | DRTL     |        |
  | ALTX     |        |
  | DWRF     |        |
  +----------+--------+

To merge the files on just the "name" and "lod_score" fields and sort on the name:

  $ tabmerge -f name,lod_score -s name merge*
  +----------+-----------+
  | name     | lod_score |
  +----------+-----------+
  | ALTX     |           |
  | DRTL     |           |
  | DWRF     |           |
  | RM104    |           |
  | RM105    |           |
  | TX5509   |           |
  | UU189    | 2.4       |
  | Xpsm122  | 1.2       |
  | Xpsr9556 | 1.2       |
  +----------+-----------+

To do the same but mimic the original tab-delimited input:

  $ tabmerge -f name,lod_score -s name --stdout merge*
  name    lod_score
  ALTX
  DRTL
  DWRF
  RM104
  RM105
  TX5509
  UU189   2.4
  Xpsm122 1.2
  Xpsr9556        1.2

Why would you want to do this? Suppose you have several delimited text files with nearly the same structure and want to create just one file from them, but the fields may be in a different order in each file and/or some files may contain more or fewer fields than others. (As far-fetched as it may seem, it happens to the author more than he'd like.)

SEE ALSO

•   Text::RecordParser

•   Text::TabularDisplay

AUTHOR
Ken Youens-Clark <kclark@cpan.org>.

LICENSE AND COPYRIGHT
Copyright (C) 2006-10 Ken Youens-Clark. All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; version 2.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.